
<a name="globalsmd"></a>

[functional-firestore](#globalsmd)

# functional-firestore

## Index

### External modules

* ["Arbitraries"](#modules_arbitraries_md)
* ["Emulator"](#modules_emulator_md)
* ["Firestore"](#modules_firestore_md)
* ["index"](#modules_index_md)


<a name="readmemd"></a>

[functional-firestore](#globalsmd)

# functional-firestore


# Interfaces


<a name="interfaces_firestore_modelmd"></a>

[functional-firestore](#globalsmd) › ["Firestore"](#modules_firestore_md) › [Model](#interfaces_firestore_modelmd)

## Interface: Model

### Hierarchy

* **Model**

### Index

#### Properties

* [id](#id)

### Properties

####  id

• **id**: *string*

Defined in src/Firestore.ts:34

# Modules


<a name="modules_arbitraries_md"></a>

[functional-firestore](#globalsmd) › ["Arbitraries"](#modules_arbitraries_md)

## External module: "Arbitraries"

### Index

#### Functions

* [condition](#const-condition)
* [id](#const-id)
* [model](#const-model)
* [modelAndConditions](#const-modelandconditions)
* [modelAndUpdate](#const-modelandupdate)
* [modelBase](#const-modelbase)
* [modelData](#const-modeldata)
* [models](#const-models)
* [nonEmptyString](#const-nonemptystring)
* [nonModelObject](#const-nonmodelobject)
* [operation](#const-operation)
* [table](#const-table)

### Functions

#### `Const` condition

▸ **condition**(): *Arbitrary‹[Condition](#condition)›*

Defined in src/Arbitraries.ts:40

**Returns:** *Arbitrary‹[Condition](#condition)›*

___

#### `Const` id

▸ **id**(): *Arbitrary‹string›*

Defined in src/Arbitraries.ts:7

**Returns:** *Arbitrary‹string›*

___

#### `Const` model

▸ **model**(): *Arbitrary‹[Model](#interfaces_firestore_modelmd)›*

Defined in src/Arbitraries.ts:24

**Returns:** *Arbitrary‹[Model](#interfaces_firestore_modelmd)›*

___

#### `Const` modelAndConditions

▸ **modelAndConditions**(): *Arbitrary‹[[Model](#interfaces_firestore_modelmd), [Condition](#condition)[]]›*

Defined in src/Arbitraries.ts:43

**Returns:** *Arbitrary‹[[Model](#interfaces_firestore_modelmd), [Condition](#condition)[]]›*

___

#### `Const` modelAndUpdate

▸ **modelAndUpdate**(): *Arbitrary‹[[Model](#interfaces_firestore_modelmd), [Model](#interfaces_firestore_modelmd)]›*

Defined in src/Arbitraries.ts:29

**Returns:** *Arbitrary‹[[Model](#interfaces_firestore_modelmd), [Model](#interfaces_firestore_modelmd)]›*

___

#### `Const` modelBase

▸ **modelBase**(): *Arbitrary‹[Model](#interfaces_firestore_modelmd)›*

Defined in src/Arbitraries.ts:12

**Returns:** *Arbitrary‹[Model](#interfaces_firestore_modelmd)›*

___

#### `Const` modelData

▸ **modelData**(): *Arbitrary‹object›*

Defined in src/Arbitraries.ts:17

**Returns:** *Arbitrary‹object›*

___

#### `Const` models

▸ **models**(): *Arbitrary‹[Model](#interfaces_firestore_modelmd)[]›*

Defined in src/Arbitraries.ts:57

**Returns:** *Arbitrary‹[Model](#interfaces_firestore_modelmd)[]›*

___

#### `Const` nonEmptyString

▸ **nonEmptyString**(): *Arbitrary‹string›*

Defined in src/Arbitraries.ts:5

**Returns:** *Arbitrary‹string›*

___

#### `Const` nonModelObject

▸ **nonModelObject**(): *Arbitrary‹unknown›*

Defined in src/Arbitraries.ts:9

**Returns:** *Arbitrary‹unknown›*

___

#### `Const` operation

▸ **operation**(): *Arbitrary‹[Operation](#operation)›*

Defined in src/Arbitraries.ts:38

**Returns:** *Arbitrary‹[Operation](#operation)›*

___

#### `Const` table

▸ **table**(): *Arbitrary‹string›*

Defined in src/Arbitraries.ts:59

**Returns:** *Arbitrary‹string›*


<a name="modules_emulator_md"></a>

[functional-firestore](#globalsmd) › ["Emulator"](#modules_emulator_md)

## External module: "Emulator"

### Index

#### Functions

* [clearCollection](#const-clearcollection)
* [clearEmulator](#const-clearemulator)
* [clearFirestore](#const-clearfirestore)
* [getFirestore](#const-getfirestore)

### Functions

#### `Const` clearCollection

▸ **clearCollection**(`parentCollection`: CollectionReference‹object›): *Promise‹void›*

Defined in src/Emulator.ts:25

```haskell
clearCollection :: Collection -> Promise
```

**Parameters:**

Name | Type |
------ | ------ |
`parentCollection` | CollectionReference‹object› |

**Returns:** *Promise‹void›*

___

#### `Const` clearEmulator

▸ **clearEmulator**(): *Promise‹void›*

Defined in src/Emulator.ts:56

```haskell
clearFirebase :: () -> Promise
```

**Returns:** *Promise‹void›*

___

#### `Const` clearFirestore

▸ **clearFirestore**(): *Promise‹void›*

Defined in src/Emulator.ts:46

```haskell
clearFirestore :: () -> Promise
```

**Returns:** *Promise‹void›*

___

#### `Const` getFirestore

▸ **getFirestore**(): *Firestore‹›*

Defined in src/Emulator.ts:16

```haskell
getFirestore :: () -> Firestore
```

**Returns:** *Firestore‹›*


<a name="modules_firestore_md"></a>

[functional-firestore](#globalsmd) › ["Firestore"](#modules_firestore_md)

## External module: "Firestore"

### Index

#### Interfaces

* [Model](#interfaces_firestore_modelmd)

#### Type aliases

* [Condition](#condition)
* [Operation](#operation)

#### Variables

* [getDocumentSnapshotsFromQuerySnapshot](#const-getdocumentsnapshotsfromquerysnapshot)
* [getModelFromCollection](#const-getmodelfromcollection)
* [getModelFromDocument](#const-getmodelfromdocument)
* [getModelFromFirestore](#const-getmodelfromfirestore)
* [getModelsFromQuery](#const-getmodelsfromquery)
* [getModelsFromQuerySnapshot](#const-getmodelsfromquerysnapshot)
* [getModelsInCollection](#const-getmodelsincollection)
* [getModelsInCollectionWhere](#const-getmodelsincollectionwhere)
* [getModelsInFirestore](#const-getmodelsinfirestore)
* [getModelsInFirestoreWhere](#const-getmodelsinfirestorewhere)
* [getSnapshotFromDocument](#const-getsnapshotfromdocument)
* [getSnapshotFromQuery](#const-getsnapshotfromquery)
* [storeModelToCollection](#const-storemodeltocollection)
* [storeModelToDocument](#const-storemodeltodocument)
* [storeModelToFirestore](#const-storemodeltofirestore)
* [updateModelInDocument](#const-updatemodelindocument)
* [validateModel](#const-validatemodel)
* [validateSnapshotExistence](#const-validatesnapshotexistence)

#### Functions

* [getCollectionFromDocument](#const-getcollectionfromdocument)
* [getCollectionFromFirestore](#const-getcollectionfromfirestore)
* [getDocumentFromCollection](#const-getdocumentfromcollection)
* [getQueryFromCollection](#const-getqueryfromcollection)
* [getSnapshotFromDocumentTask](#const-getsnapshotfromdocumenttask)
* [getSnapshotFromQueryTask](#const-getsnapshotfromquerytask)
* [isModel](#const-ismodel)
* [listCollectionsInFirestore](#const-listcollectionsinfirestore)
* [listDocumentsInCollection](#const-listdocumentsincollection)
* [storeModelToFirestoreWith](#const-storemodeltofirestorewith)
* [updateModelInDocumentTask](#const-updatemodelindocumenttask)

### Type aliases

####  Condition

Ƭ **Condition**: *[string, [Operation](#operation), unknown]*

Defined in src/Firestore.ts:39

___

####  Operation

Ƭ **Operation**: *WhereFilterOp*

Defined in src/Firestore.ts:37

### Variables

#### `Const` getDocumentSnapshotsFromQuerySnapshot

• **getDocumentSnapshotsFromQuerySnapshot**: *function* = prop('docs')

Defined in src/Firestore.ts:361

```haskell
getDocumentSnapshotsFromQuerySnapshot :: QuerySnapshot -> [DocumentSnapshot]
```

##### Type declaration:

▸ (`snapshot`: QuerySnapshot): *QueryDocumentSnapshot[]*

**Parameters:**

Name | Type |
------ | ------ |
`snapshot` | QuerySnapshot |

___

#### `Const` getModelFromCollection

• **getModelFromCollection**: *function* = pipe(
  getSnapshotFromCollection,
  RTE.chainEitherK(getModelFromDocumentSnapshot)
)

Defined in src/Firestore.ts:281

```haskell
getModelFromCollection :: Collection -> ReaderTaskEither Model Model Error
```

##### Type declaration:

▸ (`collection`: CollectionReference): *ReaderTaskEither‹[Model](#interfaces_firestore_modelmd), Error, [Model](#interfaces_firestore_modelmd)›*

**Parameters:**

Name | Type |
------ | ------ |
`collection` | CollectionReference |

___

#### `Const` getModelFromDocument

• **getModelFromDocument**: *function* = pipe(
  getSnapshotFromDocument,
  TE.chainEitherK(getModelFromDocumentSnapshot)
)

Defined in src/Firestore.ts:327

```haskell
getModelFromDocument :: Document -> TaskEither Model Error
```

##### Type declaration:

▸ (`document`: DocumentReference): *TaskEither‹Error, [Model](#interfaces_firestore_modelmd)›*

**Parameters:**

Name | Type |
------ | ------ |
`document` | DocumentReference |

___

#### `Const` getModelFromFirestore

• **getModelFromFirestore**: *function* = pipe(
  getCollectionFromFirestore,
  R.map(getModelFromCollection)
)

Defined in src/Firestore.ts:293

```haskell
getModelFromFirestore :: Firestore -> Reader String (ReaderTaskEither Model Model Error)
```

##### Type declaration:

▸ (`firestore`: Firestore): *Reader‹string, ReaderTaskEither‹[Model](#interfaces_firestore_modelmd), Error, [Model](#interfaces_firestore_modelmd)››*

**Parameters:**

Name | Type |
------ | ------ |
`firestore` | Firestore |

___

#### `Const` getModelsFromQuery

• **getModelsFromQuery**: *function* = pipe(
  getSnapshotFromQuery,
  TE.chainEitherK(getModelsFromQuerySnapshot)
)

Defined in src/Firestore.ts:383

```haskell
getModelsFromQuery :: Query -> TaskEither [Model] Error
```

##### Type declaration:

▸ (`query`: Query): *TaskEither‹Error, [Model](#interfaces_firestore_modelmd)[]›*

**Parameters:**

Name | Type |
------ | ------ |
`query` | Query |

___

#### `Const` getModelsFromQuerySnapshot

• **getModelsFromQuerySnapshot**: *function* = pipe(
  getDocumentSnapshotsFromQuerySnapshot,
  map(getModelFromDocumentSnapshot),
  A.array.sequence(E.either)
)

Defined in src/Firestore.ts:370

```haskell
getModelsFromQuerySnapshot :: QuerySnapshot -> Either [Model] Error
```

##### Type declaration:

▸ (`snapshot`: QuerySnapshot): *E.Either‹Error, [Model](#interfaces_firestore_modelmd)[]›*

**Parameters:**

Name | Type |
------ | ------ |
`snapshot` | QuerySnapshot |

___

#### `Const` getModelsInCollection

• **getModelsInCollection**: *function* = pipe(
  listDocumentsInCollection,
  TEUtils.fromTask,
  TE.chain(pipe(map(getModelFromDocument), A.array.sequence(TE.taskEither)))
)

Defined in src/Firestore.ts:420

```haskell
getModelsInCollection :: Collection -> TaskEither [Model] Error
```

##### Type declaration:

▸ (`collection`: CollectionReference): *TaskEither‹Error, [Model](#interfaces_firestore_modelmd)[]›*

**Parameters:**

Name | Type |
------ | ------ |
`collection` | CollectionReference |

___

#### `Const` getModelsInCollectionWhere

• **getModelsInCollectionWhere**: *function* = pipe(
  getQueryFromCollection,
  RTE.fromReaderEither,
  RTE.chainTaskEitherK(getModelsFromQuery)
)

Defined in src/Firestore.ts:395

```haskell
getModelsInCollectionWhere :: Collection -> ReaderTaskEither [Condition] [Model] Error
```

##### Type declaration:

▸ (`collection`: CollectionReference): *ReaderTaskEither‹[Condition](#condition)[], Error, [Model](#interfaces_firestore_modelmd)[]›*

**Parameters:**

Name | Type |
------ | ------ |
`collection` | CollectionReference |

___

#### `Const` getModelsInFirestore

• **getModelsInFirestore**: *function* = pipe(
  getCollectionFromFirestore,
  R.map(getModelsInCollection)
)

Defined in src/Firestore.ts:433

```haskell
getModelsInFirestore :: Firestore -> ReaderTaskEither String [Model] Error
```

##### Type declaration:

▸ (`firestore`: Firestore): *ReaderTaskEither‹string, Error, [Model](#interfaces_firestore_modelmd)[]›*

**Parameters:**

Name | Type |
------ | ------ |
`firestore` | Firestore |

___

#### `Const` getModelsInFirestoreWhere

• **getModelsInFirestoreWhere**: *function* = pipe(
  getCollectionFromFirestore,
  R.map(getModelsInCollectionWhere)
)

Defined in src/Firestore.ts:408

```haskell
getModelsInFirestoreWhere :: Firestore -> Reader String (ReaderTaskEither [Condition] [Model] Error)
```

##### Type declaration:

▸ (`firestore`: Firestore): *Reader‹string, ReaderTaskEither‹[Condition](#condition)[], Error, [Model](#interfaces_firestore_modelmd)[]››*

**Parameters:**

Name | Type |
------ | ------ |
`firestore` | Firestore |

___

#### `Const` getSnapshotFromDocument

• **getSnapshotFromDocument**: *function* = pipe(
  getSnapshotFromDocumentTask,
  TEUtils.fromTask
)

Defined in src/Firestore.ts:211

```haskell
getSnapshotFromDocument :: Document -> TaskEither Snapshot Error
```

##### Type declaration:

▸ (`document`: DocumentReference): *TaskEither‹Error, DocumentSnapshot›*

**Parameters:**

Name | Type |
------ | ------ |
`document` | DocumentReference |

___

#### `Const` getSnapshotFromQuery

• **getSnapshotFromQuery**: *function* = pipe(
  getSnapshotFromQueryTask,
  TEUtils.fromTask
)

Defined in src/Firestore.ts:349

```haskell
getSnapshotFromQuery :: Query -> TaskEither Snapshot Error
```

##### Type declaration:

▸ (`query`: Query): *TaskEither‹Error, QuerySnapshot›*

**Parameters:**

Name | Type |
------ | ------ |
`query` | Query |

___

#### `Const` storeModelToCollection

• **storeModelToCollection**: *function* = pipe(
  getDocumentFromCollection,
  R.chain(storeModelToDocument)
)

Defined in src/Firestore.ts:136

```haskell
storeModelToCollection :: Collection -> String -> ReaderTaskEither Model Model Error
```

##### Type declaration:

▸ (`collection`: CollectionReference): *ReaderTaskEither‹[Model](#interfaces_firestore_modelmd), Error, [Model](#interfaces_firestore_modelmd)›*

**Parameters:**

Name | Type |
------ | ------ |
`collection` | CollectionReference |

___

#### `Const` storeModelToDocument

• **storeModelToDocument**: *function* = pipe(
  storeModelToDocumentTask,
  R.map(TEUtils.fromTask)
)

Defined in src/Firestore.ts:124

```haskell
storeModelToDocument :: Document -> ReaderTaskEither Model Model Error
```

##### Type declaration:

▸ (`document`: DocumentReference): *ReaderTaskEither‹[Model](#interfaces_firestore_modelmd), Error, [Model](#interfaces_firestore_modelmd)›*

**Parameters:**

Name | Type |
------ | ------ |
`document` | DocumentReference |

___

#### `Const` storeModelToFirestore

• **storeModelToFirestore**: *function* = pipe(
  getCollectionFromFirestore,
  R.map(storeModelToCollection)
)

Defined in src/Firestore.ts:148

```haskell
storeModelToFirestore :: Firestore -> Reader String (ReaderTaskEither Model Model Error)
```

##### Type declaration:

▸ (`firestore`: Firestore): *Reader‹string, ReaderTaskEither‹[Model](#interfaces_firestore_modelmd), Error, [Model](#interfaces_firestore_modelmd)››*

**Parameters:**

Name | Type |
------ | ------ |
`firestore` | Firestore |

___

#### `Const` updateModelInDocument

• **updateModelInDocument**: *function* = pipe(
  updateModelInDocumentTask,
  R.map(TEUtils.fromTask)
)

Defined in src/Firestore.ts:189

```haskell
updateModelInDocument :: Collection -> ReaderTaskEither Model Model Error
```

##### Type declaration:

▸ (`document`: DocumentReference): *ReaderTaskEither‹[Model](#interfaces_firestore_modelmd), Error, [Model](#interfaces_firestore_modelmd)›*

**Parameters:**

Name | Type |
------ | ------ |
`document` | DocumentReference |

___

#### `Const` validateModel

• **validateModel**: *function* = ifElse(isModel, E.right, () =>
  E.left(new Error('Item is not a valid model.'))
)

Defined in src/Firestore.ts:257

```haskell
validateModel :: a -> Either Model Error
```

##### Type declaration:

▸ (`a`: unknown): *E.Either‹Error, [Model](#interfaces_firestore_modelmd)›*

**Parameters:**

Name | Type |
------ | ------ |
`a` | unknown |

___

#### `Const` validateSnapshotExistence

• **validateSnapshotExistence**: *function* = ifElse(prop('exists'), E.right, () =>
  E.left(new Error('Item does not exist.'))
)

Defined in src/Firestore.ts:246

```haskell
validateSnapshotExistence :: snapshot -> Either a Error
```

##### Type declaration:

▸ (`snapshot`: DocumentSnapshot): *E.Either‹Error, DocumentSnapshot›*

**Parameters:**

Name | Type |
------ | ------ |
`snapshot` | DocumentSnapshot |

### Functions

#### `Const` getCollectionFromDocument

▸ **getCollectionFromDocument**(`document`: DocumentReference‹object›): *(Anonymous function)*

Defined in src/Firestore.ts:100

```haskell
getCollectionFromDocument :: Document -> Reader String Collection
```

**Parameters:**

Name | Type |
------ | ------ |
`document` | DocumentReference‹object› |

**Returns:** *(Anonymous function)*

___

#### `Const` getCollectionFromFirestore

▸ **getCollectionFromFirestore**(`firestore`: Firestore‹›): *(Anonymous function)*

Defined in src/Firestore.ts:56

```haskell
getCollectionFromFirestore :: Firestore -> Reader String Collection
```

**Parameters:**

Name | Type |
------ | ------ |
`firestore` | Firestore‹› |

**Returns:** *(Anonymous function)*

___

#### `Const` getDocumentFromCollection

▸ **getDocumentFromCollection**(`collection`: CollectionReference‹object›): *(Anonymous function)*

Defined in src/Firestore.ts:67

```haskell
getDocumentFromCollection :: Collection -> Reader Model Document
```

**Parameters:**

Name | Type |
------ | ------ |
`collection` | CollectionReference‹object› |

**Returns:** *(Anonymous function)*

___

#### `Const` getQueryFromCollection

▸ **getQueryFromCollection**(`collection`: CollectionReference‹object›): *function*

Defined in src/Firestore.ts:78

```haskell
getQueryFromCollection :: Collection -> Reader [Condition] Document Error
```

**Parameters:**

Name | Type |
------ | ------ |
`collection` | CollectionReference‹object› |

**Returns:** *function*

▸ (`x0`: V0): *T2*

**Parameters:**

Name | Type |
------ | ------ |
`x0` | V0 |

___

#### `Const` getSnapshotFromDocumentTask

▸ **getSnapshotFromDocumentTask**(`document`: DocumentReference‹object›): *(Anonymous function)*

Defined in src/Firestore.ts:203

```haskell
getSnapshotFromDocumentTask :: Document -> Task Snapshot
```

**Parameters:**

Name | Type |
------ | ------ |
`document` | DocumentReference‹object› |

**Returns:** *(Anonymous function)*

___

#### `Const` getSnapshotFromQueryTask

▸ **getSnapshotFromQueryTask**(`query`: Query‹object›): *(Anonymous function)*

Defined in src/Firestore.ts:341

```haskell
getSnapshotFromQueryTask :: Query -> Task Snapshot
```

**Parameters:**

Name | Type |
------ | ------ |
`query` | Query‹object› |

**Returns:** *(Anonymous function)*

___

#### `Const` isModel

▸ **isModel**(`a`: unknown): *a is Model*

Defined in src/Firestore.ts:46

```haskell
isModel :: a -> bool
```

**Parameters:**

Name | Type |
------ | ------ |
`a` | unknown |

**Returns:** *a is Model*

___

#### `Const` listCollectionsInFirestore

▸ **listCollectionsInFirestore**(`firestore`: Firestore‹›): *(Anonymous function)*

Defined in src/Firestore.ts:307

```haskell
listCollectionsInFirestore :: Firestore -> Task [Collection]
```

**Parameters:**

Name | Type |
------ | ------ |
`firestore` | Firestore‹› |

**Returns:** *(Anonymous function)*

___

#### `Const` listDocumentsInCollection

▸ **listDocumentsInCollection**(`collection`: CollectionReference‹object›): *(Anonymous function)*

Defined in src/Firestore.ts:318

```haskell
listDocumentsInCollection :: Collection -> Task [Document]
```

**Parameters:**

Name | Type |
------ | ------ |
`collection` | CollectionReference‹object› |

**Returns:** *(Anonymous function)*

___

#### `Const` storeModelToFirestoreWith

▸ **storeModelToFirestoreWith**<**A**>(`firestore`: any): *(Anonymous function)*

Defined in src/Firestore.ts:165

```haskell
storeModelToFirestoreWith :: Firestore -> Reader String (ReaderTaskEither (() -> Model) Model Error)
```

**Type parameters:**

▪ **A**

**Parameters:**

Name | Type |
------ | ------ |
`firestore` | any |

**Returns:** *(Anonymous function)*

___

#### `Const` updateModelInDocumentTask

▸ **updateModelInDocumentTask**(`document`: DocumentReference‹object›): *(Anonymous function)*

Defined in src/Firestore.ts:177

```haskell
updateModelInDocumentTask :: Collection -> ReaderTask Model Model
```

**Parameters:**

Name | Type |
------ | ------ |
`document` | DocumentReference‹object› |

**Returns:** *(Anonymous function)*


<a name="modules_index_md"></a>

[functional-firestore](#globalsmd) › ["index"](#modules_index_md)

## External module: "index"

### Index

#### References

* [Condition](#condition)
* [Model](#model)
* [Operation](#operation)
* [getCollectionFromDocument](#getcollectionfromdocument)
* [getCollectionFromFirestore](#getcollectionfromfirestore)
* [getDocumentFromCollection](#getdocumentfromcollection)
* [getDocumentSnapshotsFromQuerySnapshot](#getdocumentsnapshotsfromquerysnapshot)
* [getModelFromCollection](#getmodelfromcollection)
* [getModelFromDocument](#getmodelfromdocument)
* [getModelFromFirestore](#getmodelfromfirestore)
* [getModelsFromQuery](#getmodelsfromquery)
* [getModelsFromQuerySnapshot](#getmodelsfromquerysnapshot)
* [getModelsInCollection](#getmodelsincollection)
* [getModelsInCollectionWhere](#getmodelsincollectionwhere)
* [getModelsInFirestore](#getmodelsinfirestore)
* [getModelsInFirestoreWhere](#getmodelsinfirestorewhere)
* [getQueryFromCollection](#getqueryfromcollection)
* [getSnapshotFromDocument](#getsnapshotfromdocument)
* [getSnapshotFromDocumentTask](#getsnapshotfromdocumenttask)
* [getSnapshotFromQuery](#getsnapshotfromquery)
* [getSnapshotFromQueryTask](#getsnapshotfromquerytask)
* [isModel](#ismodel)
* [listCollectionsInFirestore](#listcollectionsinfirestore)
* [listDocumentsInCollection](#listdocumentsincollection)
* [storeModelToCollection](#storemodeltocollection)
* [storeModelToDocument](#storemodeltodocument)
* [storeModelToFirestore](#storemodeltofirestore)
* [storeModelToFirestoreWith](#storemodeltofirestorewith)
* [updateModelInDocument](#updatemodelindocument)
* [updateModelInDocumentTask](#updatemodelindocumenttask)
* [validateModel](#validatemodel)
* [validateSnapshotExistence](#validatesnapshotexistence)

### References

####  Condition

• **Condition**:

___

####  Model

• **Model**:

___

####  Operation

• **Operation**:

___

####  getCollectionFromDocument

• **getCollectionFromDocument**:

___

####  getCollectionFromFirestore

• **getCollectionFromFirestore**:

___

####  getDocumentFromCollection

• **getDocumentFromCollection**:

___

####  getDocumentSnapshotsFromQuerySnapshot

• **getDocumentSnapshotsFromQuerySnapshot**:

___

####  getModelFromCollection

• **getModelFromCollection**:

___

####  getModelFromDocument

• **getModelFromDocument**:

___

####  getModelFromFirestore

• **getModelFromFirestore**:

___

####  getModelsFromQuery

• **getModelsFromQuery**:

___

####  getModelsFromQuerySnapshot

• **getModelsFromQuerySnapshot**:

___

####  getModelsInCollection

• **getModelsInCollection**:

___

####  getModelsInCollectionWhere

• **getModelsInCollectionWhere**:

___

####  getModelsInFirestore

• **getModelsInFirestore**:

___

####  getModelsInFirestoreWhere

• **getModelsInFirestoreWhere**:

___

####  getQueryFromCollection

• **getQueryFromCollection**:

___

####  getSnapshotFromDocument

• **getSnapshotFromDocument**:

___

####  getSnapshotFromDocumentTask

• **getSnapshotFromDocumentTask**:

___

####  getSnapshotFromQuery

• **getSnapshotFromQuery**:

___

####  getSnapshotFromQueryTask

• **getSnapshotFromQueryTask**:

___

####  isModel

• **isModel**:

___

####  listCollectionsInFirestore

• **listCollectionsInFirestore**:

___

####  listDocumentsInCollection

• **listDocumentsInCollection**:

___

####  storeModelToCollection

• **storeModelToCollection**:

___

####  storeModelToDocument

• **storeModelToDocument**:

___

####  storeModelToFirestore

• **storeModelToFirestore**:

___

####  storeModelToFirestoreWith

• **storeModelToFirestoreWith**:

___

####  updateModelInDocument

• **updateModelInDocument**:

___

####  updateModelInDocumentTask

• **updateModelInDocumentTask**:

___

####  validateModel

• **validateModel**:

___

####  validateSnapshotExistence

• **validateSnapshotExistence**:
